1155ee9877a5df419f2fd89ab06fa1baed5d0e65
[xfstests-dev.git] / tests / generic / 046
1 #! /bin/bash
2 # FSQA Test No. 046
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1    # failure is the default!
32 trap "exit \$status" 0 1 2 3 15
33
34 # get standard environment, filters and checks
35 . ./common/rc
36 . ./common/filter
37
38 # real QA test starts here
39 _supported_fs generic
40 _supported_os Linux
41
42 _require_scratch
43 _require_scratch_shutdown
44 _require_xfs_io_command "fiemap"
45 _scratch_mkfs >/dev/null 2>&1
46 _require_metadata_journaling $SCRATCH_DEV
47 _scratch_mount
48
49 # create files
50 i=1;
51 while [ $i -lt 1000 ]
52 do
53         file=$SCRATCH_MNT/$i
54         $XFS_IO_PROG -f -c "pwrite -b 32k -S 0xff 0 32k" $file > /dev/null
55         if [ $? -ne 0 ]
56         then
57                 echo error creating/writing file $file
58                 exit
59         fi
60         $XFS_IO_PROG -c "truncate 64k" $file > /dev/null
61         if [ $? -ne 0 ]
62         then
63                 echo error truncating file $file
64                 exit
65         fi
66         let i=$i+1
67 done
68
69 # give the system a chance to write something out
70 sleep 10
71
72 _scratch_shutdown
73
74 _scratch_unmount
75 _scratch_mount
76 _scratch_unmount
77 if [ ! _check_scratch_fs ]
78 then
79         echo error detected in filesystem
80         exit
81 fi
82 _scratch_mount
83
84 # check file size and contents
85 i=1;
86 while [ $i -lt 1000 ]
87 do
88         file=$SCRATCH_MNT/$i
89         # if file does not exist, the create was not logged, skip it
90         if [ -e $file ]
91         then
92                 # if file size is zero it cannot be corrupt, skip it
93                 if [ -s $file ]
94                 then
95                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
96                         num_extents=`_count_extents $file`
97                         if [ $num_extents -eq 0 ]; then
98                                 echo corrupt file $file - non-zero size but no extents
99                         else
100                                 rm -f $file
101                         fi
102                 else
103                         rm -f $file
104                 fi
105         fi
106         let i=$i+1
107 done
108
109 status=0
110 exit